/*
**
**	Buttons read and debounce
*/

#include "processor.h"
#include "../delay/delay.h"
#include "buttons.h"

int readKEY( void)
{   // returns 0.F if key pressed, 0 = none
    int c = 0;

    if ( !_RD6) // leftmost button 
        c |= 8;
    if ( !_RD7)
        c |= 4;
    if ( !_RA7)
        c |= 2;
    if ( !_RD13) // rightmost button
        c |= 1;

    return c;
} // readKEY


int getKEY( void)
{   // wait for a key pressed and debounce
    int i=0, c;
    
    // wait for a key pressed for at least .1sec
    do{
        Delayms( 10);
        if ( c = readKEY())
            i++;
        else 
            i=0;
    } while ( i<10);

    // wait for key released for at least .1 sec
    i =0;
    do {
        Delayms( 10);   
        if ( readKEY())
            i=0;
        else i++;
    } while ( i<10);

    return c;
} // getKEY
