/*
**
** LCD.c
**
** 7/30/06 LDJ v1.0
*/

#include "LCDnoPMP.h"

void initLCD( void)
{
    // PMP initialization 
    PORTE = 0;
    TRISE = 0xFF00;
    RW = 0;
    RS = 0;
    E = 0;
    RW_TRIS = 0;
    RS_TRIS = 0;
    E_TRIS = 0;
    
    // init TMR1
    T1CON = 0x8030;             // Fosc/2, prescaled 1:256, 6.4us/tick
    // wait for >30ms
    TMR1 = 0; while( TMR1<5000);// 5000 x 6.4us = 32ms   
    
    //initiate the HD44780 display 8-bit init sequence
    RS = LCDCMD;            // command register
    PORTE = 0b00111000;        // 8-bit interface, 2 lines, 5x7
    clockLCD();
    TMR1 = 0; while( TMR1<9);   // 3 x 16us = 48us   
    
    PORTE = 0b00001100;        // display ON, cursor off, blink off
    clockLCD();
    TMR1 = 0; while( TMR1<9);   // 3 x 16us = 48us   
    
    PORTE = 0b00000001;        // clear display
    clockLCD();
    TMR1 = 0; while( TMR1<300); // 100 x 16us = 1.6ms   
    
    PORTE = 0b00000110;        // increment cursor, no shift
    clockLCD();
    TMR1 = 0; while( TMR1<300); // 100 x 16us = 1.6ms   
} // initLCD


char readLCD( int addr)
{
    int dummy;
    TRISE = 0xffff;
    RS = addr;              // select the command address
    RW = 1;
    clockLCD();
    dummy = PORTE;
    TRISE = 0;
    return( (char)dummy );            // read the status register
    
    
} // readLCD


void writeLCD( int addr, char c)    
{
    // init TMR1
    TRISE = 0xff00;
    T1CON = 0x8030;             // Fosc/2, prescaled 1:256, 16us/tick
    TMR1 = 0; while( TMR1<300); // 100 x 16us = 1.6ms  
    RW = 0;
    RS = addr;
    PORTE = c;
    clockLCD();
    TRISE = 0xffff;
} // writeLCD
    

void putsLCD( char *s)
{
    while( *s) putLCD( *s++);
} //putsLCD



