/*
**
** LCD.h
**
** 7/30/06 LDJ v1.0
*/

#include "processor.h"

#define LCDDATA 1
#define LCDCMD  0
#define PMDATA  PMDIN1

// Control signal data pins for dsPIC
#define  RW  LATDbits.LATD5       // LCD R/W signal
#define  RS  LATBbits.LATB15      // LCD RS signal
#define  E   LATDbits.LATD4       // LCD E signal 

// Control signal pin direction for dsPIC
#define  RW_TRIS	TRISDbits.TRISD5 
#define  RS_TRIS	TRISBbits.TRISB15
#define  E_TRIS		TRISDbits.TRISD4

void initLCD( void);
char readLCD( int addr);

#define busyLCD() readLCD( LCDCMD) & 0x80
#define addrLCD() readLCD( LCDCMD) & 0x7F
#define getLCD()  readLCD( LCDDATA)

#define clockLCD() {E = 1; Nop(); Nop(); Nop(); E = 0;}


void writeLCD( int addr, char c);    

#define putLCD( d)  writeLCD( LCDDATA, (d))
#define cmdLCD( c)  writeLCD( LCDCMD, (c))

#define homeLCD()   writeLCD( LCDCMD, 2)    
#define clrLCD()    writeLCD( LCDCMD, 1)
#define setLCDG( a) writeLCD( LCDCMD, (a & 0x3F) | 0x40)
#define setLCDC( a) writeLCD( LCDCMD, (a & 0x7F) | 0x80)

void putsLCD( char *s);



