/*
** SD card interface 
** 
** 7/20/06 LDJ rev 1.4
**
*/

#define TRUE    1
#define FALSE   0
#define FAIL    0

// IO definitions
#define SD_LED                      _RA0
#define READ_LED                    _RA1
#define WRITE_LED                   _RA2


typedef unsigned long LBA;      // logic block address, 32 bit wide

typedef struct
{
    unsigned CSD_STRUCTURE      :2; //byte 0
    unsigned RESERVED1          :6;
    unsigned TAAC               :8; // byte 1
    
    unsigned NSAC               :8; // byte 2
    unsigned TRAN_SPEED         :8; // byte 3
    
    unsigned CCC               :12; // byte 4
    unsigned READ_BL_LEN        :4; // byte 5
       
    unsigned READ_BL_PARTIAL    :1; // byte 6
    unsigned WRITE_BLK_MISALIGN :1;
    unsigned READ_BLK_MISALIGN  :1;
    unsigned DSR_IMP            :1;

    unsigned RESERVED2          :2;
    unsigned C_SIZE            :12; 
    unsigned VDD_R_CURR_MIN     :3; // byte 8
    unsigned VDD_R_CURR_MAX     :3; 
    unsigned VDD_W_CUR_MIN      :3; // byte 9
    unsigned VDD_W_CURR_MAX     :3;

    unsigned C_MULT             :3; // byte 10               
    unsigned ERASE_BLK_EN       :1;
    unsigned SECTOR_SIZE        :7; 
    unsigned WP_GRP_SIZE        :7;
    unsigned WP_GRP_ENABLE      :1; 

    unsigned RESERVED3          :2;
    unsigned R2W_FACTOR         :3;
    unsigned WRITE_BL_LEN       :4;
    unsigned WRITE_BL_PARTIAL   :1;
    unsigned RESERVED4          :5;

    unsigned FILE_FORMAT_GRP    :1; // byte 14
    unsigned COPY               :1;
    unsigned PERM_WRITE_PROTECT :1;
    unsigned TMP_WRITE_PROTECT  :1;
    unsigned FILE_FORMAT        :2;

    unsigned RESERVED5          :2;    
    unsigned CRC                :7; // byte 15
    unsigned NOT_USED           :1;
} CSD;


void initSD( void);
int initMedia( void);

int detectSD( void);
int detectWP( void);

int readSECTOR ( LBA, char *);
int writeSECTOR( LBA, char *);
int readCSD(char *);

